package com.sun.org.apache.xpath.internal.objects;

import org.xml.sax.ext.LexicalHandler;
import org.xml.sax.SAXException;
import org.xml.sax.ContentHandler;
import com.sun.org.apache.xml.internal.utils.FastStringBuffer;
import com.sun.org.apache.xpath.internal.res.XPATHMessages;

public class XStringForChars extends XString
{
    static final long serialVersionUID = -2235248887220850467L;
    int m_start;
    int m_length;
    protected String m_strCache;
    
    public XStringForChars(char[] val, int start, int length) {
        super(val);
        this.m_strCache = null;
        this.m_start = start;
        this.m_length = length;
        if (null == val) {
            throw new IllegalArgumentException(XPATHMessages.createXPATHMessage("ER_FASTSTRINGBUFFER_CANNOT_BE_NULL", (Object[])null));
        }
        return;
    }
    
    private XStringForChars(String val) {
        super(val);
        this.m_strCache = null;
        throw new IllegalArgumentException(XPATHMessages.createXPATHMessage("ER_XSTRINGFORCHARS_CANNOT_TAKE_STRING", (Object[])null));
    }
    
    public FastStringBuffer fsb() {
        throw new RuntimeException(XPATHMessages.createXPATHMessage("ER_FSB_NOT_SUPPORTED_XSTRINGFORCHARS", (Object[])null));
    }
    
    @Override
    public void appendToFsb(FastStringBuffer fsb) {
        fsb.append((char[])(char[])this.m_obj, this.m_start, this.m_length);
    }
    
    @Override
    public boolean hasString() {
        return null != this.m_strCache;
    }
    
    @Override
    public String str() {
        if (null == this.m_strCache) {
            this.m_strCache = new String((char[])(char[])this.m_obj, this.m_start, this.m_length);
        }
        return this.m_strCache;
    }
    
    @Override
    public Object object() {
        return this.str();
    }
    
    @Override
    public void dispatchCharactersEvents(ContentHandler ch) throws SAXException {
        ch.characters((char[])(char[])this.m_obj, this.m_start, this.m_length);
    }
    
    @Override
    public void dispatchAsComment(LexicalHandler lh) throws SAXException {
        lh.comment((char[])(char[])this.m_obj, this.m_start, this.m_length);
    }
    
    @Override
    public int length() {
        return this.m_length;
    }
    
    @Override
    public char charAt(int index) {
        return ((char[])(char[])this.m_obj)[index + this.m_start];
    }
    
    @Override
    public void getChars(int srcBegin, int srcEnd, char[] dst, int dstBegin) {
        System.arraycopy((char[])(char[])this.m_obj, this.m_start + srcBegin, dst, dstBegin, srcEnd);
    }
}
